package Test;

public interface TestItemDataWriterOperations extends
    DDS.DataWriterOperations
{

    long register_instance(
            Test.TestItem instance_data);

    long register_instance_w_timestamp(
            Test.TestItem instance_data, 
            DDS.Time_t source_timestamp);

    int unregister_instance(
            Test.TestItem instance_data, 
            long handle);

    int unregister_instance_w_timestamp(
            Test.TestItem instance_data, 
            long handle, 
            DDS.Time_t source_timestamp);

    int write(
            Test.TestItem instance_data, 
            long handle);

    int write_w_timestamp(
            Test.TestItem instance_data, 
            long handle, 
            DDS.Time_t source_timestamp);

    int dispose(
            Test.TestItem instance_data, 
            long instance_handle);

    int dispose_w_timestamp(
            Test.TestItem instance_data, 
            long instance_handle, 
            DDS.Time_t source_timestamp);
    
    int writedispose(
            Test.TestItem instance_data, 
            long instance_handle);

    int writedispose_w_timestamp(
            Test.TestItem instance_data, 
            long instance_handle, 
            DDS.Time_t source_timestamp);

    int get_key_value(
            Test.TestItemHolder key_holder, 
            long handle);
    
    long lookup_instance(
            Test.TestItem instance_data);

}
